


function [xdata, dependentData] = gendata(n, j, betasTrue) 

  % specify dimension of random coefficients 
  
  k = size(betasTrue, 2);

  % define iota vector for matrix multiplication                  
  
  iota = ones(j, 1);
  
  % generate product characteristics from uniform distributions
  
  xdata = [5 * rand(n * j, 1), -4 * rand(n * j, 1) + 1];
  
  
  % calculate linear index
  
  betaMat = betasTrue(ceil((1:j * size(betasTrue, 1)) / (j)), :);
  
  linearIndex = betaMat .* xdata;
  
  linearIndex = linearIndex * ones(k, 1);
  
    
  % calculate logit kernels
  
  expLinearIndex = reshape(exp(linearIndex), j, n)';
  
  expLinearIndexSum = 1 + (expLinearIndex * iota);
  
  choiceProbs = expLinearIndex ./ repmat(expLinearIndexSum, [1, j]);
  
  
  % add share of outside option
  
  outsideShare = 1 - (choiceProbs * iota);
  
  choiceProbsWithOutside = [choiceProbs outsideShare];
  
  
  % generate choices
  
  choiceData = zeros(n, 1);
  
  for i = 1:n
    
    q = cumsum(choiceProbsWithOutside(i, :)) / sum(choiceProbsWithOutside(i, :));
    
    rs = rand(1);
    
    choiceData(i) = sum(rs > q) + 1;
    
  end

  
  % transform choice data to binary variable for linear probability model
    
   dependentDataMat = zeros(n, j + 1); 
   
   for i = 1:n
       
       dependentDataMat(i, choiceData(i)) = 1;
   
   end
      
    % reshape data for regression
    
    dependentData = reshape(dependentDataMat(:, 1:j)', 1, [])';
    

end