




estimator = function(choiceProbsR, dependentData, mu, j, eps = 1e-05) {
  
  require("limSolve")
  
  # specify number of grid points
  
  R = ncol(choiceProbsR)
  
  
  # specify equality constraint

  E = matrix(1, nrow = 1, ncol = R);    f = 1
  
  # specify inequality constraint 
  
  G = diag(1, R);   h = rep(0, R)
  
  
  # specify regressor matrix and dependent variable
  
  b =  c(dependentData, rep(0, R))
  
  A = rbind(choiceProbsR, sqrt(mu) * diag(1, R))    
  
  
  # estimate coefficients with lsei function from limSolve package
  
  out = lsei(A = A, B = b, E = E, F = f, G = G, H = h, type = 2, verbose = TRUE)
  
  theta = out$X
  
  theta = theta * (theta > eps)
  
  
  # return estimated weights 
  
  return(list(theta = theta))
  
}




