


gmdist = function(n, mus, sigmas, probs) {
  
  require("MASS")
  

  # sepcify dimension and number of mixture components

  m = nrow(mus);      k = ncol(mus)
  
  
  # sample mixture component for every observation unit
  
  z = sample(1:m, n, replace = TRUE, prob = probs)
  
  
  # draw betas from every component
  
  betas = matrix(double(n * k), nrow = n, ncol = k) 
  
  for(i in 1:m) {
    
    betas[z == i, ] = mvrnorm(sum(z == i), mu = mus[i, ], Sigma = sigmas[, , i], 
    
                              tol = 1e-10, empirical = FALSE, EISPACK = FALSE)
    
  }
  
  
  # return matrix with betas
  
  return(betas)

}