

halton_grid = function(r, k, primeNumbers) {
  

  # create empty matrix to save draws
  
  gridR = matrix(double(r * k), nrow = r , ncol = k)
  
  
  # generate Halton draws for each dimension
  
  for(i in 1:k) {
  
    # select prime number 
    
    pni = primeNumbers[i]
    
    # generate Halton sequence
    
    draws = 0;  test = 0;   t = 1
    
    while(test == 0) {
      
      st = draws
      
      for(m in 1:(pni-1)) {
        
        d = m / (pni)^t
        
        draws = rbind(draws, (st + d))
        
        # test if sufficiently many draws
        
        test = length(draws) >= (r + 10)
        
        if(test == TRUE)  break 
        
      }
      
      # update t
      
      t = t + 1
      
    }
    
    # discard first 10 draws
    
    draws = draws[11:(r + 10)]  
    
    # save matrix
    
    gridR[, i] = t(draws)
    
  }
  
  # return draws
  
  return(gridR)

  
}


