


library(MASS);    library(limSolve);    library(mvtnorm);   library(glmnet);    library(Matrix)


# load functions

setwd("/Functions/")

source("gendata.R");    source("cdfEst.R");       source("cdfTrue.R")

source("gmdist.R");     source("estimator.R");    source("crossValidation.R");    

setwd("/Monte_Carlos/MC_Discrete/")

source("MC_Discrete_function.R")



# specify parameter of Monte Carlo experiments

Nvec = c(1000, 10000);    Rvec = c(25, 81, 289)


# define parameters to generate data

j = 4;    k = 2;   E = sqrt(10000);  nFolds = 10


# set up a grid for evaluation

gridE = as.matrix(expand.grid(seq(-4.5, 3.5, length.out = E), seq(-4.5, 3.5, length.out = E)))


# get arguments from batch job

args = (commandArgs(TRUE))

mcr = as.integer(args[1]) + 1


# sepcify path to save function output 

path = ''


# conduct Monte Carlo experiments (To replicate the Monte Carlo experiments 200 times, you have to call the function MC_Discrete() 200 times.
# We ran the Monte Carlo experiment on a HPC and sent this file, MC_Discrete_Parallel.R, 200 times to the cluster.)

MC_Discrete(path, mcr, Nvec, Rvec)


